﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Winform
{
    public partial class Form1 : Form
    {
        //考题库
        List<Question> questions = new List<Question>();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.label2.Visible = false;
            this.label3.Visible = false;
            this.label4.Visible = false;
            this.label5.Visible = false;
        }

        /// <summary>
        /// 产生考题
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnGenerate_Click(object sender, EventArgs e)
        {

            Random r = new Random();
            //循环生成10道考题           
            for (int i = 1; i <= 18; i++)
            {
                Question question = new Question();
                question.Id = i;
                //随机正确考题位置               
                switch (r.Next(1, 4))
                {
                    case 1: question.A = i + ""; question.B = r.Next(100) + ""; question.C = r.Next(100) + ""; question.D = r.Next(100) + ""; break;
                    case 2: question.B = i + ""; question.A = r.Next(100) + ""; question.C = r.Next(100) + ""; question.D = r.Next(100) + ""; break;
                    case 3: question.C = i + ""; question.B = r.Next(100) + ""; question.A = r.Next(100) + ""; question.D = r.Next(100) + ""; break;
                    case 4: question.D = i + ""; question.B = r.Next(100) + ""; question.C = r.Next(100) + ""; question.A = r.Next(100) + ""; break;
                }
                question.Title = "这是第" + i + "题,题号为：（  ）";  
               
                questions.Add(question);
            }

            //调用方法生成考题
            GenerateQuestion();
        }
        /// <summary>
        /// //根据考题库动态生成考题
        /// </summary>
        /// <param name="questions"></param>
        void GenerateQuestion()
        {
            //用于保存上一次生成的考题，以便设置当前考题的位置
            Button btn = new Button();
            btn.Location = new System.Drawing.Point(3, 3); //初始化位置参数
            btn.Size = new System.Drawing.Size(0, 50);
            //每个按钮间距
            int size = 0;

            //循环读出考题
            for (int i = 0; i < questions.Count; i++)
            {
                Button btnQuestion = new Button();
                //将设计文件的样式拷到这吧               
                btnQuestion.BackColor = System.Drawing.Color.Lime;
                btnQuestion.Size = new System.Drawing.Size(50, 50);
                //换行时改变题目的高度
                if (i % 4 == 0 && i != 0)
                {
                    btnQuestion.Location = new System.Drawing.Point(3, btn.Location.Y + btn.Size.Height + size);
                }
                else
                {
                    btnQuestion.Location = new System.Drawing.Point(btn.Location.X + btn.Size.Width + size, btn.Location.Y);
                    size = 2;
                }
                btnQuestion.Name = "btnQuesiton" + i;
                btnQuestion.TabIndex = i;
                btnQuestion.Text = questions[i].Id.ToString();

                //为每到考题单击事件绑定相同的处理方法
                btnQuestion.Click += new System.EventHandler(this.btnQuestion_Click);
                btn = btnQuestion;
                //将考题加进容器里
                this.panel1.Controls.Add(btnQuestion);
            }
        }

        //考题号
        int questionId;
        /// <summary>
        /// 考题点击事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void btnQuestion_Click(object sender, EventArgs e)
        {
            Button btn = sender as Button;
            questionId = int.Parse(btn.Text.ToString());
            //查找考题进行绑定
            Question ques = questions.Find(EndsWithSaurus);
            if (ques != null)
            {
                this.label2.Visible = true;
                this.label3.Visible = true;
                this.label4.Visible = true;
                this.label5.Visible = true;
                this.lblTitle.Text = ques.Title;
                this.lblB.Text = ques.B;
                this.lblC.Text = ques.C;
                this.lblD.Text = ques.D;
                this.lblA.Text = ques.A;
            }
        }

        bool EndsWithSaurus(Question q)
        {
            if (q.Id == questionId)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

    }
}
